import matplotlib.pyplot as plt
import os
import numpy as np
import glob
import cv2

# Load directory of images
directory=glob.glob(os.path.join('Images_mixture','*.jpg'))

# Image for unmix and mix intensity calculation
image_serpentine = cv2.imread(directory[1])

plt.imshow(cv2.cvtColor(image_serpentine, cv2.COLOR_BGR2RGB))
plt.show()

# Unmix intensity calculation
pos_y_u = 1235
pos_x_u = 835
image_unmix_window = image_serpentine[pos_y_u:pos_y_u+100,pos_x_u:pos_x_u+100]
h_u,w_u,c_u = image_unmix_window.shape
vect_unmix=np.zeros(h_u*w_u)
n=0
for i in range(h_u):
    for j in range(w_u):
        vect_unmix[n]=np.sqrt(0.241* (image_unmix_window [i,j,0] ** 2) + 0.691* (image_unmix_window [i,j,1] ** 2) +
0.068* (image_unmix_window [i,j,2]**2))
        n+=1
I_unmix=np.mean(vect_unmix) 
I_unmix_max=vect_unmix.max()
I_unmix_min=vect_unmix.min()

plt.imshow(cv2.cvtColor(image_unmix_window, cv2.COLOR_BGR2RGB))
plt.show()

# Mix intensity calculation
pos_y_m = 1250
pos_x_m = 3990
image_mix_window = image_serpentine[pos_y_m:pos_y_m+100,pos_x_m:pos_x_m+100]
h_m,w_m,c_m = image_mix_window.shape
vect_mix=np.zeros(h_m*w_m)
n=0
for i in range(h_m):
    for j in range(w_m):
        vect_mix[n]=np.sqrt(0.241* (image_mix_window [i,j,0] ** 2) + 0.691* (image_mix_window [i,j,1] ** 2) +
0.068* (image_mix_window [i,j,2]**2))
        n+=1
I_mix=np.mean(vect_mix) 
I_mix_max=vect_mix.max()
I_mix_min=vect_mix.min()

plt.imshow(cv2.cvtColor(image_mix_window, cv2.COLOR_BGR2RGB))
plt.show()

# Vector to storage the values calculated for the sigma
sigma_serpentine = np.zeros(9)


# Sigma calculation
I_sum=0
c=0
N=0

pos_y = 1220
pos_x = 1850

while c<9:
    image_window = image_serpentine[pos_y:pos_y+100,pos_x:pos_x+100]
    plt.imshow(cv2.cvtColor(image_window, cv2.COLOR_BGR2RGB))
    plt.show()          
    h,w,l = image_window.shape
    for i in range(h):
        for j in range(w):
            I=np.sqrt(0.241* (image_window[i,j,0] ** 2) + 0.691* (image_window[i,j,1] ** 2) +
0.068* (image_window[i,j,2]**2))
            I_sum += ((I-I_mix)/(I_unmix-I_mix))**2
            N+=1
  
    sigma_serpentine[c] = 1-np.sqrt((1/N)*(I_sum))
    c+=1
    I_sum=0
    N=0
    pos_x +=225

# Image for unmix and mix intensity calculation
image_cirfeatures = cv2.imread(directory[3])

plt.imshow(cv2.cvtColor(image_cirfeatures, cv2.COLOR_BGR2RGB))
plt.show()

# Unmix intensity calculation
pos_y_u = 635
pos_x_u = 160
image_unmix_window = image_cirfeatures[pos_y_u:pos_y_u+100,pos_x_u:pos_x_u+100]
h_u,w_u,c_u = image_unmix_window.shape
vect_unmix=np.zeros(h_u*w_u)
n=0
for i in range(h_u):
    for j in range(w_u):
        vect_unmix[n]=np.sqrt(0.241* (image_unmix_window [i,j,0] ** 2) + 0.691* (image_unmix_window [i,j,1] ** 2) +
0.068* (image_unmix_window [i,j,2]**2))
        n+=1
I_unmix=np.mean(vect_unmix) 
I_unmix_max=vect_unmix.max()
I_unmix_min=vect_unmix.min()

plt.imshow(cv2.cvtColor(image_unmix_window, cv2.COLOR_BGR2RGB))
plt.show()

# Mix intensity calculation
pos_y_m = 560
pos_x_m = 4295
image_mix_window = image_cirfeatures[pos_y_m:pos_y_m+100,pos_x_m:pos_x_m+100]
h_m,w_m,c_m = image_mix_window.shape
vect_mix=np.zeros(h_m*w_m)
n=0
for i in range(h_m):
    for j in range(w_m):
        vect_mix[n]=np.sqrt(0.241* (image_mix_window [i,j,0] ** 2) + 0.691* (image_mix_window [i,j,1] ** 2) +
0.068* (image_mix_window [i,j,2]**2))
        n+=1
I_mix=np.mean(vect_mix) 
I_mix_max=vect_mix.max()
I_mix_min=vect_mix.min()

plt.imshow(cv2.cvtColor(image_mix_window, cv2.COLOR_BGR2RGB))
plt.show()

# Vector to storage the values calculated for the sigma
sigma_cirfeatures = np.zeros(6)


# Sigma calculation
I_sum=0
c=0
N=0

pos_y_1 = 120
pos_x_1 = 765
pos_y_2 = 1250
pos_x_2 = 1380

while c<6:
    if c%2==0:
        image_window = image_cirfeatures[pos_y_1:pos_y_1+100,pos_x_1:pos_x_1+100]
    else:
        image_window = image_cirfeatures[pos_y_2:pos_y_2+100,pos_x_2:pos_x_2+100]
    plt.imshow(cv2.cvtColor(image_window, cv2.COLOR_BGR2RGB))
    plt.show()          
    h,w,l = image_window.shape
    for i in range(h):
        for j in range(w):
            I=np.sqrt(0.241* (image_window[i,j,0] ** 2) + 0.691* (image_window[i,j,1] ** 2) +
0.068* (image_window[i,j,2]**2))
            I_sum += ((I-I_mix)/(I_unmix-I_mix))**2
            N+=1
  
    sigma_cirfeatures[c] = 1-np.sqrt((1/N)*(I_sum))
    if c%2==0:
        pos_x_1 +=1220
        pos_y_1 +=5
    else:
        pos_x_2 +=1190
        pos_y_2 +=5
    c+=1
    I_sum=0
    N=0

# Image for unmix and mix intensity calculation
image_SARS = cv2.imread(directory[5])

plt.imshow(cv2.cvtColor(image_SARS, cv2.COLOR_BGR2RGB))
plt.show()

# Unmix intensity calculation
pos_y_u = 785
pos_x_u = 430
image_unmix_window = image_SARS[pos_y_u:pos_y_u+50,pos_x_u:pos_x_u+50]
h_u,w_u,c_u = image_unmix_window.shape
vect_unmix=np.zeros(h_u*w_u)
n=0
for i in range(h_u):
    for j in range(w_u):
        vect_unmix[n]=np.sqrt(0.241* (image_unmix_window [i,j,0] ** 2) + 0.691* (image_unmix_window [i,j,1] ** 2) +
0.068* (image_unmix_window [i,j,2]**2))
        n+=1
I_unmix=np.mean(vect_unmix) 
I_unmix_max=vect_unmix.max()
I_unmix_min=vect_unmix.min()

plt.imshow(cv2.cvtColor(image_unmix_window, cv2.COLOR_BGR2RGB))
plt.show()

# Mix intensity calculation
pos_y_m = 775
pos_x_m = 4025
image_mix_window = image_SARS[pos_y_m:pos_y_m+50,pos_x_m:pos_x_m+50]
h_m,w_m,c_m = image_mix_window.shape
vect_mix=np.zeros(h_m*w_m)
n=0
for i in range(h_m):
    for j in range(w_m):
        vect_mix[n]=np.sqrt(0.241* (image_mix_window [i,j,0] ** 2) + 0.691* (image_mix_window [i,j,1] ** 2) +
0.068* (image_mix_window [i,j,2]**2))
        n+=1
I_mix=np.mean(vect_mix) 
I_mix_max=vect_mix.max()
I_mix_min=vect_mix.min()

plt.imshow(cv2.cvtColor(image_mix_window, cv2.COLOR_BGR2RGB))
plt.show()

# Vector to storage the values calculated for the sigma
sigma_SARS = np.zeros(7)


# Sigma calculation
I_sum=0
c=0
N=0

pos_y_1 = 330
pos_x_1 = 965
pos_y_2 = 1200
pos_x_2 = 1400


while c<7:
    if c%2==0:
        image_window = image_SARS[pos_y_1:pos_y_1+90,pos_x_1:pos_x_1+90]
    else:
        image_window = image_SARS[pos_y_2:pos_y_2+90,pos_x_2:pos_x_2+90]
    plt.imshow(cv2.cvtColor(image_window, cv2.COLOR_BGR2RGB))
    plt.show()          
    h,w,l = image_window.shape
    for i in range(h):
        for j in range(w):
            I=np.sqrt(0.241* (image_window[i,j,0] ** 2) + 0.691* (image_window[i,j,1] ** 2) +
0.068* (image_window[i,j,2]**2))
            I_sum += ((I-I_mix)/(I_unmix-I_mix))**2
            N+=1  
    sigma_SARS[c] = 1-np.sqrt((1/N)*(I_sum))
    if c%2==0:
        pos_x_1 +=885
    else:
        pos_x_2 +=870
    c+=1
    I_sum=0
    N=0
   
  
pos_y_u = 1200
pos_x_u = 1400+870+870+870
image_unmix_window = image_SARS[pos_y_u:pos_y_u+100,pos_x_u:pos_x_u+100]
plt.imshow(cv2.cvtColor(image_unmix_window, cv2.COLOR_BGR2RGB))
plt.show()

# Image for unmix and mix intensity calculation
image_chambers = cv2.imread(directory[7])

plt.imshow(cv2.cvtColor(image_chambers, cv2.COLOR_BGR2RGB))
plt.show()

# Unmix intensity calculation
pos_y_u = 430
pos_x_u = 145
image_unmix_window = image_chambers[pos_y_u:pos_y_u+50,pos_x_u:pos_x_u+50]
h_u,w_u,c_u = image_unmix_window.shape
vect_unmix=np.zeros(h_u*w_u)
n=0
for i in range(h_u):
    for j in range(w_u):
        vect_unmix[n]=np.sqrt(0.241* (image_unmix_window [i,j,0] ** 2) + 0.691* (image_unmix_window [i,j,1] ** 2) +
0.068* (image_unmix_window [i,j,2]**2))
        n+=1
I_unmix=np.mean(vect_unmix) 
I_unmix_max=vect_unmix.max()
I_unmix_min=vect_unmix.min()

plt.imshow(cv2.cvtColor(image_unmix_window, cv2.COLOR_BGR2RGB))
plt.show()

# Mix intensity calculation
pos_y_m = 445
pos_x_m = 3620
image_mix_window = image_chambers[pos_y_m:pos_y_m+50,pos_x_m:pos_x_m+50]
h_m,w_m,c_m = image_mix_window.shape
vect_mix=np.zeros(h_m*w_m)
n=0
for i in range(h_m):
    for j in range(w_m):
        vect_mix[n]=np.sqrt(0.241* (image_mix_window [i,j,0] ** 2) + 0.691* (image_mix_window [i,j,1] ** 2) +
0.068* (image_mix_window [i,j,2]**2))
        n+=1
I_mix=np.mean(vect_mix) 
I_mix_max=vect_mix.max()
I_mix_min=vect_mix.min()

plt.imshow(cv2.cvtColor(image_mix_window, cv2.COLOR_BGR2RGB))
plt.show()

# Vector to storage the values calculated for the sigma
sigma_chambers = np.zeros(8)


# Sigma calculation
I_sum=0
c=0
N=0

pos_y = 520
pos_x = 330


while c<8:
    image_window = image_chambers[pos_y:pos_y+100,pos_x:pos_x+100]
    plt.imshow(cv2.cvtColor(image_window, cv2.COLOR_BGR2RGB))
    plt.show()          
    h,w,l = image_window.shape
    for i in range(h):
        for j in range(w):
            I=np.sqrt(0.241* (image_window[i,j,0] ** 2) + 0.691* (image_window[i,j,1] ** 2) +
0.068* (image_window[i,j,2]**2))
            I_sum += ((I-I_mix)/(I_unmix-I_mix))**2
            N+=1
  
    sigma_chambers[c] = 1-np.sqrt((1/N)*(I_sum))
    pos_x +=460
    c+=1
    I_sum=0
    N=0


